<template>
  <LineChart
    style="height:250px;"
    :chart-data="dataCollection"
    :options="options"
    :height="null"
    :width="null"
  />
</template>

<script>
import LineChart from './LineChart'
export default {
  name: 'ActivityChart',
  components: {
    LineChart
  },
  props: {
    history: {
      required: true,
      type: Array
    }
  },
  data () {
    return {
      dataCollection: {},
      options: {
        responsive: true,
        maintainAspectRatio: false,
        aspectRatio: 2,
        title: {
          display: true,
          text: this.$t('player.activity_chart_title')
        },
        scales: {
          xAxes: [{
            gridLines: {
              color: '#282828'
            },
            stacked: false
          }],
          yAxes: [{
            gridLines: {
              color: '#282828'
            },
            stacked: false
          }]
        }
      }
    }
  },
  computed: {
    pveBattles () {
      let prev = (this.history[0].pve || {}).gamePlayed
      const arr = this.history.map((history) => {
        const diff = (history.pve || {}).gamePlayed - prev
        prev = (history.pve || {}).gamePlayed
        return diff
      })
      return arr
    },
    pvpBattles () {
      let prev = (this.history[0].pvp || {}).gamePlayed
      const arr = this.history.map((history) => {
        const diff = (history.pvp || {}).gamePlayed - prev
        prev = (history.pvp || {}).gamePlayed
        return diff
      })
      return arr
    },
    coopBattles () {
      let prev = (this.history[0].coop || {}).gamePlayed
      const arr = this.history.map((history) => {
        const diff = (history.coop || {}).gamePlayed - prev
        prev = (history.coop || {}).gamePlayed
        return diff
      })
      return arr
    },
    days () {
      const arr = this.history.map((history) => {
        const date = new Date(history.createdAt)
        const arr = date.toUTCString().split(' ')
        return arr[1] + ' ' + arr[2]
      })
      return arr
    }
  },
  mounted () {
    this.dataCollection = {
      labels: this.days,
      datasets: [{
        label: this.$t('pvp.pvp'),
        borderColor: 'red',
        data: this.pvpBattles
      }, {
        label: this.$t('pve.pve'),
        borderColor: 'green',
        data: this.pveBattles
      }, {
        label: this.$t('coop.coop'),
        borderColor: 'blue',
        data: this.coopBattles
      }]
    }
  }
}
</script>
